`timescale 1 ns / 1 ps
module tb_iglu_multicoin;
  reg CLOCK, RESET;
  reg [2:0] COIN;
  wire ICE;

  `include "iglu_multicoin_defs.v"

  // Instanz des Verkaufsautomaten
  iglu_multicoin UUT (.CLOCK(CLOCK), .RESET(RESET),
                      .COIN(COIN), .ICE(ICE));

  // Takt
  always
    #20 CLOCK = ~CLOCK;

  // Ergebnis drucken
  initial begin
    $display ("                Zeit Reset Eisausgabe\n");
    $monitor ("%d   %d     %d", $time, RESET, ICE);
  end

  // Stimuli anlegen: Muenzen eingeben
  initial begin
    CLOCK = 0; COIN = X0; RESET = 1'b1;
    #50 RESET = 1'b0;
    @(negedge CLOCK);
    // drei Fuenfziger
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    // einen Fuenfziger, dann einen Euro
    #160 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    #80 $display ("Einwurf 100 Ct"); COIN = X100; #40 COIN = X0;
    // zwei Euro (keine Rueckgabe!)
    #160 $display ("Einwurf 100 Ct"); COIN = X100; #40 COIN = X0;
    #80 $display ("Einwurf 100 Ct"); COIN = X100; #40 COIN = X0;
    // einen Euro, dann einen Fuenfziger
    #160 $display ("Einwurf 100 Ct"); COIN = X100; #40 COIN = X0;
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    // zwei Euro
    #160 $display ("Einwurf 200 Ct"); COIN = X200; #40 COIN = X0;
    // 6 Zehner, 2 Zwanziger, ein Fuenziger
    #160 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 20 Ct"); COIN = X20; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 20 Ct"); COIN = X20; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $stop;
  end

endmodule
